program Fatman;
{$B-,I-,R-,S-}
type PointType=record
                 X,Y:Integer;
                 R:Real;
               end;
     PointVector=array[1..320] of PointType;
var P,P1,P2:PointVector;
    L,W,NSets,N,N1,N2,PCor,SetCount:Integer;

procedure PushPoint(X,Y:Integer);
begin
  Inc(N);
  P[N].X:=X;
  P[N].Y:=Y;
end;

procedure ReadData;
var i,j,k,NO:Integer;
begin
  PCor:=0;
  ReadLn(L,W);
  ReadLn(NO);
  N:=0;
  for k:=1 to NO do
    begin
      ReadLn(i,j);
      if (j<>0) and (j<>W) then PushPoint(i,j);
    end;
  for i:=0 to L do
    begin
      PushPoint(i,0);
      PushPoint(i,W);
    end;
end;

procedure SortPoints;
var i,j,k:Integer;
    PAux:PointType;
begin
  for i:=1 to N-1 do
    begin
      k:=i;
      for j:=i+1 to N do
        if (P[j].X<P[k].X) or ((P[j].X=P[k].X) and (P[j].Y<P[k].Y))
          then k:=j;
      PAux:=P[i];P[i]:=P[k];P[k]:=PAux;
    end;
end;

procedure InitFront;
var i:Integer;
begin
  N1:=0;
  repeat
    Inc(N1);
    Inc(PCor);
    P1[N1]:=P[N1];
    P1[N1].R:=P[N1+1].Y-P[N1].Y;
  until P[N1].Y=W;
  P1[N1].R:=0;
end;

procedure Max(var R:Real;Q:Real);
begin
  if Q>R then R:=Q;
end;

function Min(R,Q:Real):Real;
begin
  if Q>R then Min:=R else Min:=Q;
end;

procedure FindR(var R:Real;Y1,Y2:Real);
var i:Integer;
    X1,X2:Real;
begin
  R:=0;
  for i:=1 to N1-1 do
    begin
      X1:=P1[i].Y;
      X2:=P1[i+1].Y;
      if (X1>=Y2) or (X2<=Y1)
        then Max(R,1)
        else if (X1>=Y1) and (X2<=Y2)
        then Max(R,P1[i].R)
        else if (X1<=Y1) and (X2>=Y2)
        then begin
               Max(R,Min(Y2-Y1,P1[i].R));
             end
        else if (X1>=Y1) and (X2>=Y2)
        then Max(R,Min(Sqrt(1+(Y2-X1)*(Y2-X1)),P1[i].R))
        else Max(R,Min(Sqrt(1+(X2-Y1)*(X2-Y1)),P1[i].R));
    end;
end;

procedure MakeNewFront;
begin
  N2:=1;
  Inc(PCor);
  P2[1]:=P[PCor];
  repeat
    Inc(N2);
    Inc(PCor);
    P2[N2]:=P[PCor];
    FindR(P2[N2-1].R,P2[N2-1].Y,P2[N2].Y);
  until P2[N2].Y=W;
  P2[N2].R:=0;
end;

procedure WriteBest;
var i:Integer;
    BestR:Real;
begin
  BestR:=0;
  for i:=1 to N1-1 do
    if P1[i].R>BestR then BestR:=P1[i].R;
  WriteLn('Marimea maxima in testul ',SetCount,' este ',BestR:0:4);
end;

begin
  Assign(Input,'grasan.inp');Reset(Input);
  ReadLn(NSets);
  for SetCount:=1 to NSets do
    begin
      ReadData;
      SortPoints;
      InitFront;
      repeat
        MakeNewFront;
        P1:=P2;N1:=N2;
      until PCor=N;
      WriteBest;
    end;
  Close(Input);
end.
